import Qt 4.7

Item {
    id: xaqmlFolderTypePicker
    width: 250
    height: 364

    property bool enabled: true

    property bool folderFlagged: true
    property string folderFlaggedResult: ""

    property string folderTypeString : ""
    property int repeaterTypeSegmentSelected

    signal folderFlaggingUpdated()
    signal folderTypeStringResultUpdated()

    onFolderTypeStringChanged: {
        //console.debug("QML++ xaqmlFolderTypePicker onFolderTypeStringChanged")
        //console.debug(folderTypeString)

        // 0 = Project
        // 1 = Folder (Generic)
        // 2 = Meeting

        if (folderTypeString.charAt(0) == "1") repeaterTypeSegmentSelected = 1;
        else if (folderTypeString.charAt(0) == "2") repeaterTypeSegmentSelected = 2;
        else repeaterTypeSegmentSelected = 0;

        segmentGrid.currentIndex = repeaterTypeSegmentSelected
    }


    function updateFolderTypeString() {
        //console.debug("QML++ xaqmlFolderTypePicker updateFolderTypeString")
        //console.debug(repeaterTypeSegmentSelected)

        if (repeaterTypeSegmentSelected == 1) folderTypeString = "1";
        else if (repeaterTypeSegmentSelected == 2) folderTypeString = "2";
        else folderTypeString = "0";

        //console.debug(folderTypeString)
        folderTypeStringResultUpdated()
    }

    ListModel {
        id: segmentModel

        ListElement {
            name: "Project"
            checked: "1"
        }
        ListElement {
            name: "Folder"
            checked: "0"
        }
        ListElement {
            name: "Meeting"
            checked: "0"
        }
    }

    //
    // flagging on/off control
    //

    onFolderFlaggedChanged: {
        //console.debug("QML++ onFolderFlaggedChanged")
        flaggingOnOff.switchOn = xaqmlFolderTypePicker.folderFlagged
        flaggingOnOff.loadSettings();

        if (folderFlagged) iconPreviewFlaggingImage.source = "pics/FolderIconMonoFolderFlagged80.png"
        else iconPreviewFlaggingImage.source = "pics/FolderIconMonoFolder80.png"
    }

    Item {
        id: flaggingOnOffControl
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top
        anchors.bottom: parent.bottom

        Text {
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.top: parent.top
            anchors.topMargin: -10
            anchors.leftMargin: 6
            height: 20

            color: "white"
            font.pixelSize: 12
            //font.family: "Helvetica"
            font.family: "Arial"
            font.bold: true
            smooth: true

            text: "Flagging"
        }

        Rectangle {
            id: flaggingOnOffControlRect
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.top: parent.top
            anchors.topMargin: 10
            height: 25
            clip: true
            color: "black"

            XAOnOffSelector {
                id: flaggingOnOff
                anchors.left: parent.left
                anchors.right: parent.right
                anchors.top: parent.top
                anchors.topMargin: -2

                labelText: "Item Flagged:"
                switchOn: xaqmlFolderTypePicker.folderFlagged

                onSwitchChanged: {
                    //console.debug("QML++ switch changed")

                    //if (switchOn) console.debug("SWITCH IS ON")
                    //else console.debug("SWITCH IS OFF")

                    if (switchOn) {
                        folderFlaggedResult = "1"
                        //iconPreviewFlaggingImage.source = "pics/FolderIconLightV2-P@2x.png"
                    } else {
                        folderFlaggedResult = "0"
                        //iconPreviewFlaggingImage.source = "pics/FolderIconLightV2-F@2x.png"
                    }

                    folderFlaggingUpdated();
                }
            }
        }

        Rectangle {
            id: iconPreviewFlaggingRect
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.top: parent.top
            anchors.topMargin: 36
            height: 110
            color:  "#55000000"

            Image {
                id: iconPreviewFlaggingImage
                anchors.horizontalCenter: parent.horizontalCenter
                anchors.verticalCenter: parent.verticalCenter
            }

        }
    }

    //
    // repeat segment control
    //

    Item {
        id: repeatSegmentControl
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top
        anchors.topMargin: 170
        anchors.bottom: parent.bottom

        Text {
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.top: parent.top
            anchors.topMargin: -10
            anchors.leftMargin: 6
            height: 20

            color: "white"
            font.pixelSize: 12
            //font.family: "Helvetica"
            font.family: "Arial"
            font.bold: true
            smooth: true

            text: "Folder Type"
        }

        Rectangle {
            id: repeatSegmentControlRect
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.top: parent.top
            anchors.topMargin: 10
            height: 25
            clip: true
            color: "black"

            GridView {
                id: segmentGrid
                anchors.fill: parent
                anchors.topMargin: 1
                anchors.leftMargin: 2
                anchors.rightMargin: 2

                cellWidth: parent.width / model.count - 2; cellHeight: parent.height - 4

                model: segmentModel
                delegate: segmentCellDelegate
                //highlight: Rectangle { color: "lightsteelblue"; radius: 5; smooth: true; border.color: "white"; border.width: 1}
                highlight: Rectangle { color: "#3e3c3c"; radius: 5; smooth: true; border.color: "white"; border.width: 1}
                //focus: true

                onVisibleChanged: {
                    if (visible) {
                        segmentGrid.currentIndex = repeaterTypeSegmentSelected;
                    }
                }

                onCurrentIndexChanged: {
                    //console.debug("repeaterTypeSegmentSelected onCurrentIndexChanged")

                    if (segmentGrid.currentIndex == 0) iconPreviewImage.source = "pics/FolderIconMonoProject80.png"
                    else if (segmentGrid.currentIndex == 1) iconPreviewImage.source = "pics/FolderIconMonoFolder80.png"
                    else if (segmentGrid.currentIndex == 2) iconPreviewImage.source = "pics/FolderIconMonoMeeting80.png"
                }

                Component {
                    id: segmentCellDelegate

                    Item {
                        id: segmentCellDelegateItem
                        width: segmentGrid.cellWidth; height: segmentGrid.cellHeight

                        MouseArea {
                            anchors.fill: parent
                            onClicked: {
                                segmentGrid.currentIndex = index;
                                repeaterTypeSegmentSelected = index;

                                updateFolderTypeString();
                            }
                        }

                        Column {
                            id: segmentCellDelegateColumn
                            anchors.topMargin: 2
                            anchors.bottomMargin: 2
                            anchors.left: parent.left
                            anchors.leftMargin: 1
                            anchors.right: parent.right
                            anchors.rightMargin: 1

                            Text {
                                text: name;
                                font.family: "Arial";
                                font.bold: true;
                                //font.pointSize: 11;
                                font.pixelSize: 11
                                anchors.top: parent.top
                                anchors.topMargin: 4
                                anchors.horizontalCenter: parent.horizontalCenter
                                color: "white";
                                smooth: true;
                            }
                        }
                    }
                }
            }
        }
    }

    Rectangle {
        id: iconPreviewRect
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top
        anchors.topMargin: 206
        height: 110
        color:  "#55000000"

        Image {
            id: iconPreviewImage
            anchors.horizontalCenter: parent.horizontalCenter
            anchors.verticalCenter: parent.verticalCenter
        }

    }

}
